

<!DOCTYPE html>

<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.15.19. snippet_html &#8212; Groonga v10.1.1-31-g1e46ba6 documentation</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="7.15.20. string_length" href="string_length.html" />
    <link rel="prev" title="7.15.18. rand" href="rand.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">An open-source fulltext search engine and column store.</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../ja/html/reference/functions/snippet_html.html">日本語</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="string_length.html" title="7.15.20. string_length"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="rand.html" title="7.15.18. rand"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../function.html" accesskey="U"><span class="section-number">7.15. </span>Function</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.15.19. </span><code class="docutils literal notranslate"><span class="pre">snippet_html</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="snippet-html">
<h1><span class="section-number">7.15.19. </span><code class="docutils literal notranslate"><span class="pre">snippet_html</span></code><a class="headerlink" href="#snippet-html" title="Permalink to this headline">¶</a></h1>
<div class="section" id="summary">
<h2><span class="section-number">7.15.19.1. </span>Summary<a class="headerlink" href="#summary" title="Permalink to this headline">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">snippet_html</span></code> extracts snippets of target text around search
keywords (<code class="docutils literal notranslate"><span class="pre">KWIC</span></code>. <code class="docutils literal notranslate"><span class="pre">KeyWord</span> <span class="pre">In</span> <span class="pre">Context</span></code>). The snippets are prepared
for embedding HTML. Special characters such as <code class="docutils literal notranslate"><span class="pre">&lt;</span></code> and <code class="docutils literal notranslate"><span class="pre">&gt;</span></code> are
escapsed as <code class="docutils literal notranslate"><span class="pre">&amp;lt;</span></code> and <code class="docutils literal notranslate"><span class="pre">&amp;gt;</span></code>. Keyword is surrounded with <code class="docutils literal notranslate"><span class="pre">&lt;span</span>
<span class="pre">class=&quot;keyword&quot;&gt;</span></code> and <code class="docutils literal notranslate"><span class="pre">&lt;/span&gt;</span></code>. For example, a snippet of <code class="docutils literal notranslate"><span class="pre">I</span> <span class="pre">am</span> <span class="pre">a</span>
<span class="pre">groonga</span> <span class="pre">user.</span> <span class="pre">&lt;3</span></code> for keyword <code class="docutils literal notranslate"><span class="pre">groonga</span></code> is <code class="docutils literal notranslate"><span class="pre">I</span> <span class="pre">am</span> <span class="pre">a</span> <span class="pre">&lt;span</span>
<span class="pre">class=&quot;keyword&quot;&gt;groonga&lt;/span&gt;</span> <span class="pre">user.</span> <span class="pre">&amp;lt;3</span></code>.</p>
</div>
<div class="section" id="syntax">
<h2><span class="section-number">7.15.19.2. </span>Syntax<a class="headerlink" href="#syntax" title="Permalink to this headline">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">snippet_html</span></code> has only one parameter:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>snippet_html(column)
</pre></div>
</div>
<p><code class="docutils literal notranslate"><span class="pre">snippet_html</span></code> has many parameters internally but they can’t be
specified for now. You will be able to custom those parameters soon.</p>
</div>
<div class="section" id="usage">
<h2><span class="section-number">7.15.19.3. </span>Usage<a class="headerlink" href="#usage" title="Permalink to this headline">¶</a></h2>
<p>Here are a schema definition and sample data to show usage.</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>table_create Documents TABLE_NO_KEY
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Documents content COLUMN_SCALAR Text
# [[0, 1337566253.89858, 0.000355720520019531], true]
table_create Terms TABLE_PAT_KEY ShortText --default_tokenizer TokenBigram  --normalizer NormalizerAuto
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Terms documents_content_index COLUMN_INDEX|WITH_POSITION Documents content
# [[0, 1337566253.89858, 0.000355720520019531], true]
load --table Documents
[
[&quot;content&quot;],
[&quot;Groonga is a fast and accurate full text search engine based on inverted index. One of the characteristics of groonga is that a newly registered document instantly appears in search results. Also, groonga allows updates without read locks. These characteristics result in superior performance on real-time applications.&quot;],
[&quot;Groonga is also a column-oriented database management system (DBMS). Compared with well-known row-oriented systems, such as MySQL and PostgreSQL, column-oriented systems are more suited for aggregate queries. Due to this advantage, groonga can cover weakness of row-oriented systems.&quot;]
]
# [[0, 1337566253.89858, 0.000355720520019531], 2]
</pre></div>
</div>
<p><code class="docutils literal notranslate"><span class="pre">snippet_html</span></code> can be used in only <code class="docutils literal notranslate"><span class="pre">--output_columns</span></code> in
<a class="reference internal" href="../commands/select.html"><span class="doc">select</span></a>.</p>
<p>You also need to specify <code class="docutils literal notranslate"><span class="pre">--query</span></code> and/or <code class="docutils literal notranslate"><span class="pre">--filter</span></code>. Keywords are
extracted from <code class="docutils literal notranslate"><span class="pre">--query</span></code> and <code class="docutils literal notranslate"><span class="pre">--filter</span></code> arguments.</p>
<p>The following example uses <code class="docutils literal notranslate"><span class="pre">--query</span> <span class="pre">&quot;fast</span> <span class="pre">performance&quot;</span></code>. In this
case, <code class="docutils literal notranslate"><span class="pre">fast</span></code> and <code class="docutils literal notranslate"><span class="pre">performance</span></code> are used as keywords.</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select Documents --output_columns &quot;snippet_html(content)&quot; --command_version 2 --match_columns content --query &quot;fast performance&quot;
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         1
#       ],
#       [
#         [
#           &quot;snippet_html&quot;,
#           null
#         ]
#       ],
#       [
#         [
#           &quot;Groonga is a &lt;span class=\&quot;keyword\&quot;&gt;fast&lt;/span&gt; and accurate full text search engine based on inverted index. One of the characteristics of groonga is that a newly registered document instantly appears in search results. Also, gro&quot;,
#           &quot;onga allows updates without read locks. These characteristics result in superior &lt;span class=\&quot;keyword\&quot;&gt;performance&lt;/span&gt; on real-time applications.&quot;
#         ]
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
<p><code class="docutils literal notranslate"><span class="pre">--query</span> <span class="pre">&quot;fast</span> <span class="pre">performance&quot;</span></code> matches to only the first record’s
content. <code class="docutils literal notranslate"><span class="pre">snippet_html(content)</span></code> extracts two text parts that
include the keywords <code class="docutils literal notranslate"><span class="pre">fast</span></code> or <code class="docutils literal notranslate"><span class="pre">performance</span></code> and surrounds the
keywords with <code class="docutils literal notranslate"><span class="pre">&lt;span</span> <span class="pre">class=&quot;keyword&quot;&gt;</span></code> and <code class="docutils literal notranslate"><span class="pre">&lt;/span&gt;</span></code>.</p>
<p>The max number of text parts is 3. If there are 4 or more text parts
that include the keywords, only the leading 3 parts are only used.</p>
<p>The max size of a text part is 200byte. The unit is bytes not
characters. The size doesn’t include inserted <code class="docutils literal notranslate"><span class="pre">&lt;span</span> <span class="pre">class=&quot;keyword&quot;&gt;</span></code>
and <code class="docutils literal notranslate"><span class="pre">&lt;/span&gt;</span></code>.</p>
<p>Both the max number of text parts and the max size of a text part
aren’t customizable.</p>
<p>You can specify string literal instead of column.</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select Documents --output_columns &#39;snippet_html(&quot;Groonga is very fast fulltext search engine.&quot;)&#39; --command_version 2 --match_columns content --query &quot;fast performance&quot;
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         1
#       ],
#       [
#         [
#           &quot;snippet_html&quot;,
#           null
#         ]
#       ],
#       [
#         [
#           &quot;Groonga is very &lt;span class=\&quot;keyword\&quot;&gt;fast&lt;/span&gt; fulltext search engine.&quot;
#         ]
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
</div>
<div class="section" id="return-value">
<h2><span class="section-number">7.15.19.4. </span>Return value<a class="headerlink" href="#return-value" title="Permalink to this headline">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">snippet_html</span></code> returns an array of string or <code class="docutils literal notranslate"><span class="pre">null</span></code>. If
<code class="docutils literal notranslate"><span class="pre">snippet_html</span></code> can’t find any snippets, it returns <code class="docutils literal notranslate"><span class="pre">null</span></code>.</p>
<p>An element of array is a snippet:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>[SNIPPET1, SNIPPET2, SNIPPET3]
</pre></div>
</div>
<p>A snippet includes one or more keywords. The max byte size of a
snippet except <code class="docutils literal notranslate"><span class="pre">&lt;span</span> <span class="pre">class=&quot;keyword&quot;&gt;</span></code> and <code class="docutils literal notranslate"><span class="pre">&lt;/span&gt;</span></code> is
200byte. The unit isn’t the number of characters.</p>
<p>The array size is larger than or equal to 0 and less than or equal
to 3. The max size 3 will be customizable soon.</p>
</div>
<div class="section" id="todo">
<h2><span class="section-number">7.15.19.5. </span>TODO<a class="headerlink" href="#todo" title="Permalink to this headline">¶</a></h2>
<ul class="simple">
<li><p>Make the max number of text parts customizable.</p></li>
<li><p>Make the max size of a text part customizable.</p></li>
<li><p>Make keywords customizable.</p></li>
<li><p>Make tag that surrounds a keyword customizable.</p></li>
<li><p>Make normalization customizable.</p></li>
<li><p>Support options by object literal.</p></li>
</ul>
</div>
<div class="section" id="see-also">
<h2><span class="section-number">7.15.19.6. </span>See also<a class="headerlink" href="#see-also" title="Permalink to this headline">¶</a></h2>
<ul class="simple">
<li><p><a class="reference internal" href="../commands/select.html"><span class="doc">select</span></a></p></li>
</ul>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.15.19. <code class="docutils literal notranslate"><span class="pre">snippet_html</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.15.19.1. Summary</a></li>
<li><a class="reference internal" href="#syntax">7.15.19.2. Syntax</a></li>
<li><a class="reference internal" href="#usage">7.15.19.3. Usage</a></li>
<li><a class="reference internal" href="#return-value">7.15.19.4. Return value</a></li>
<li><a class="reference internal" href="#todo">7.15.19.5. TODO</a></li>
<li><a class="reference internal" href="#see-also">7.15.19.6. See also</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="rand.html"
                        title="previous chapter"><span class="section-number">7.15.18. </span>rand</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="string_length.html"
                        title="next chapter"><span class="section-number">7.15.20. </span><code class="docutils literal notranslate"><span class="pre">string_length</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="string_length.html" title="7.15.20. string_length"
             >next</a> |</li>
        <li class="right" >
          <a href="rand.html" title="7.15.18. rand"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../function.html" ><span class="section-number">7.15. </span>Function</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.15.19. </span><code class="docutils literal notranslate"><span class="pre">snippet_html</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>